Attribute VB_Name = "basGlobe"
' Globe, Copyright Patrice Scribe, 1997-1998
' Direct3D RM sample

Option Explicit

' Based on the DirectX SDK retained mode tutorial...

' Define TEXTURE as True to use texture mapping
' Define TEXTURE as False to use material

'#Const Texture = True

'Private Declare Function DirectDrawCreateClipper Lib "ddraw" (ByVal dwFlags As Long, ByRef lplpDDCLipper As IUnknown, ByVal lng2 As Long) As Long

Const pi = 3.14159265358979

Dim D3DRM As IDirect3DRM
Dim Scene As IDirect3DRMFrame
Dim Camera As IDirect3DRMFrame
Dim Clipper As IDirectDrawClipper
Dim Device As IDirect3DRMDevice
Dim Viewport As IDirect3DRMViewPort
Dim LightFrame As IDirect3DRMFrame
Dim WorldFrame As IDirect3DRMFrame
Dim Light As IDirect3DRMLight
Dim Globe As IDirect3DRMMeshBuilder
Dim Material As IDirect3DRMMaterial
Dim Distance As Long

Public Sub ChangeDistance(Delta As Long)
    On Error GoTo ChangeDistance_Error
    Distance = Distance + Delta
    WorldFrame.SetPosition Scene, 0, 0, Distance
    Exit Sub
ChangeDistance_Error:
    If Err.Number = 11 Then Resume Next
    Stop
End Sub

Private Sub ApplyTexture(MeshBuilder As IDirect3DRMMeshBuilder, ByVal strTextureFileName As String)
    Dim Box As D3DRMBOX
    Dim MaxY As Single
    Dim MinY As Single
    Dim Height As Single
    Dim Wrap As IDirect3DRMWrap
    Dim Texture As IDirect3DRMTexture
    ' Bounding box
    MeshBuilder.GetBox Box
    MaxY = Box.Max.Y
    MinY = Box.Min.Y
    Height = MaxY - MinY
    D3DRM.CreateWrap D3DRMWRAP_CYLINDER, Nothing, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, MinY / Height, 1, -1 / Height, Wrap
    Wrap.Apply MeshBuilder
    D3DRM.LoadTexture strTextureFileName, Texture
    MeshBuilder.SetTexture Texture
End Sub
' Create a sphere (probably to improve)
Private Sub CreateSphere(objMeshBuilder As IDirect3DRMMeshBuilder)
    Dim aVertices(1 To 1000) As D3DVECTOR
    Dim aNormals(0) As D3DVECTOR
    Dim aFaces(1 To 10000) As Long
    Dim intVertices As Long
    Const stepA = 10
    Const stepB = 10
    Dim axeZ As D3DVECTOR
    Dim origine As D3DVECTOR
    With origine
        .X = 0
        .Y = 1
        .z = 0
    End With
    axeZ.X = 0
    axeZ.Y = 0
    axeZ.z = 1
    Dim AxeY As D3DVECTOR
    AxeY.X = 0
    AxeY.Y = 1
    AxeY.z = 0
    'aFaces(0) = 180 / stepA
    intVertices = 1
    Dim i As Integer
    Dim j As Integer
    Dim tmp As D3DVECTOR
    For i = stepA To 180 - stepA Step stepA
    For j = 0 To 360 - stepB Step stepB
            D3DRMVectorRotate tmp, origine, axeZ, i * pi / 180
            D3DRMVectorRotate aVertices(intVertices), tmp, AxeY, j * pi / 180
            intVertices = intVertices + 1
        Next
    Next
    intVertices = intVertices - 1
    Dim Index As Integer
    Index = 1
    For i = stepA To 180 - 2 * stepA Step stepA
        Dim FirstIndex As Long
        FirstIndex = Index
        For j = 0 To 360 - stepB Step stepB
            aFaces(Index) = 4
            aFaces(Index + 1) = (Index \ 5) + 1
            aFaces(Index + 2) = (Index \ 5)
            aFaces(Index + 3) = ((Index \ 5) + (360 \ stepB))
            aFaces(Index + 4) = (Index \ 5) + 1 + (360 \ stepB)
            If j = 360 - stepB Then
                aFaces(Index + 1) = FirstIndex \ 5  '+ 1
                aFaces(Index + 4) = FirstIndex \ 5 + (360 \ stepB)
            End If
            Index = Index + 5
        Next
    Next
    'Index = 1
    aFaces(Index) = (360 / stepB) - 1
    Index = Index + 1
    For i = 1 To (360 / stepB) - 1
        aFaces(Index) = i
        Index = Index + 1
    Next
    aFaces(Index) = 360 / stepB
    Index = Index + 1
    For i = 0 To (360 / stepB) - 1
        aFaces(Index) = intVertices - i - 1
        Index = Index + 1
    Next
    aFaces(Index) = 0
    objMeshBuilder.AddFaces intVertices, aVertices(1), 0, aNormals(0), aFaces(1), Nothing
End Sub

Private Sub Main()
    frmGlobe.Show
    Distance = 15
    Direct3DRMCreate D3DRM
    
    ' Create the scene
    D3DRM.CreateFrame Nothing, Scene
    
    ' Create the camera
    D3DRM.CreateFrame Scene, Camera
    Camera.SetPosition Scene, 0, 0, 0
    
    DirectDrawCreateClipper 0&, Clipper, Nothing
    Clipper.SetHWnd 0, frmGlobe.hWnd
    
    With frmGlobe
        D3DRM.CreateDeviceFromClipper Clipper, ByVal 0&, .ScaleX(.ScaleWidth, .ScaleMode, vbPixels), .ScaleY(.ScaleHeight, .ScaleMode, vbPixels), Device
    End With
    D3DRM.CreateViewport Device, Camera, 0, 0, Device.GetWidth, Device.GetHeight, Viewport
    Viewport.SetBack 5000
    Device.SetQuality D3DRMLIGHT_ON Or D3DRMFILL_SOLID Or D3DRMSHADE_GOURAUD
    
    ' Create the light frame
    D3DRM.CreateFrame Scene, LightFrame
    D3DRM.CreateFrame Scene, WorldFrame
    D3DRM.CreateLightRGB D3DRMLIGHT_DIRECTIONAL, 1, 1, 1, Light
    LightFrame.AddLight Light
    
    Dim light2 As IDirect3DRMLight
    
    D3DRM.CreateLightRGB D3DRMLIGHT_AMBIENT, 0.3, 0.3, 0.3, light2
    Scene.AddLight light2
    
    'Scene.SetSceneFogMode D3DRMFOG_EXPONENTIAL
    'Scene.SetSceneFogEnable True
            
    'LightFrame.SetPosition Scene, 0, 0, 0
    LightFrame.SetRotation Scene, 0, 1, 0, 0.05
    
    
    'Camera.SetPosition Scene, 0, 0, 0
    'Camera.SetOrientation Scene, 0, 0, 1, 0, 1, 0
    
    WorldFrame.SetPosition Scene, 0, 0, 15
    'WorldFrame.SetOrientation Scene, 0, 0, 1, 0, 1, 0
    WorldFrame.SetRotation Scene, 1, 1, 1, 0.17 '0.05
    
    D3DRM.CreateMeshBuilder Globe
    CreateSphere Globe
    
    'Globe.[Scale] 1, 1, 1
    'Globe.SetColorRGB 1, 1, 1
    'Globe.GenerateNormals
    
    
    ApplyTexture Globe, App.Path & "\earth1.bmp"
    ' Save the object
    'Globe.Save "Globe.x", D3DRMXOF_BINARY, 0
    
    ' You may want to play with "materials"
    'Dim objMaterial As IDirect3DRMMaterial
    'Globe.SetColorRGB 0.1, 0.1, 1
    'D3DRM.CreateMaterial 5, objMaterial
    'With objMaterial
    '    .SetEmissive 0.3, 0.3, 0.3
    '    .SetSpecular 1, 1, 1
    'End With
    'Globe.SetMaterial objMaterial
    
    WorldFrame.AddVisual Globe
    Set LightFrame = Nothing
    Set Light = Nothing
    On Error GoTo Main_Error
    Do While DoEvents() <> 0
        Scene.Move 1
        Viewport.Clear
        Viewport.Render Scene
        Device.Update
    Loop
    'Me!Timer1.Enabled = False
    Set WorldFrame = Nothing
    Set Scene = Nothing
    Set Camera = Nothing
    Set Viewport = Nothing
    Set Device = Nothing
    Set D3DRM = Nothing
    Set Clipper = Nothing
    Exit Sub
Main_Error:
    MsgBox Hex$(Err.Number)
    Stop
End Sub


